
import java.io.File;
import java.net.URLEncoder;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;
import java.util.concurrent.atomic.AtomicInteger;

import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.commons.httpclient.methods.multipart.FilePart;
import org.apache.commons.httpclient.methods.multipart.MultipartRequestEntity;
import org.apache.commons.httpclient.methods.multipart.Part;
import org.apache.commons.httpclient.methods.multipart.StringPart;

public class GupShupEmailAPIClient 
{
	private void sendFileToGupShup(String url, String filename)
	{
		try
		{
			HttpClient client = new HttpClient();
			PostMethod method = new PostMethod(url);

			File f = new File(filename);
			Part[] parts = {
							new StringPart("method", "EMS_POST_CAMPAIGN"), 
							new StringPart("userid", "2xxxxxxxxx"), 
							new StringPart("password", "xxxxxxxxxx"), 
							new StringPart("v","1.1"), 
							new StringPart("recipients", URLEncoder.encode("someone@example.com", "UTF-8")), 
							new StringPart("subject", URLEncoder.encode("Test e-statement", "UTF-8")), 
							new StringPart("content", "Testing e-statement from API gupshup"), 
							new StringPart("content_type", "text/html"), 
							new FilePart("attachment0", f),
							new StringPart("name", "Your Name")
						};

			method.setRequestEntity(new MultipartRequestEntity(parts, method.getParams()));
			int statusCode = client.executeMethod(method);
			
			System.out.println(filename + "," + method.getResponseBodyAsString());
			System.out.println(statusCode);
		}
		catch (Exception e)
		{
			System.out.println("Exception occurred.");
			e.printStackTrace();
		}
	}

	public static void main(String[] args)
	{
		String url = "http://enterprise.smsgupshup.com/GatewayAPI/rest"; 
		
		// NOTE: Put path of the file to be added as an attachment.
		String fileDir = "/home/user/GupShup/SimpleEMailTest.zip"; 

		new GupShupEmailAPIClient().sendFileToGupShup(url, fileDir);
	}
}

